Package org.springframework.beans.factory

# Interface FactoryBean<T>

Type Parameters:
  `T` - the bean type

All Known Subinterfaces:
  `SmartFactoryBean<T>`

All Known Implementing Classes:
  `AbstractFactoryBean`, `AbstractServiceLoaderBasedFactoryBean`, `FieldRetrievingFactoryBean`, `ListFactoryBean`, `MapFactoryBean`, `MethodInvokingFactoryBean`, `ObjectFactoryCreatingFactoryBean`, `PropertiesFactoryBean`, `PropertyPathFactoryBean`, `ProviderCreatingFactoryBean`, `ServiceFactoryBean`, `ServiceListFactoryBean`, `ServiceLoaderFactoryBean`, `ServiceLocatorFactoryBean`, `SetFactoryBean`, `YamlMapFactoryBean`, `YamlPropertiesFactoryBean`

public interface FactoryBean<T>
Interface to be implemented by objects used within a `BeanFactory` which are themselves factories for individual objects. If a bean implements this interface, it is used as a factory for an object to expose, not directly as a bean instance that will be exposed itself.

NB: A bean that implements this interface cannot be used as a normal bean. A FactoryBean is defined in a bean style, but the object exposed for bean references (`getObject()`) is always the object that it creates.

FactoryBeans can support singletons and prototypes, and can either create objects lazily on demand or eagerly on startup. The `SmartFactoryBean` interface allows for exposing more fine-grained behavioral metadata.

This interface is heavily used within the framework itself, for example for the AOP `org.springframework.aop.framework.ProxyFactoryBean` or the `org.springframework.jndi.JndiObjectFactoryBean`. It can be used for custom components as well; however, this is only common for infrastructure code.

`FactoryBean` is a programmatic contract. Implementations are not supposed to rely on annotation-driven injection or other reflective facilities. Invocations of `getObjectType()` and `getObject()` may arrive early in the bootstrap process, even ahead of any post-processor setup. If you need access to other beans, implement `BeanFactoryAware` and obtain them programmatically.

The container is only responsible for managing the lifecycle of the FactoryBean instance, not the lifecycle of the objects created by the FactoryBean. Therefore, a destroy method on an exposed bean object (such as `Closeable.close()`) will not be called automatically. Instead, a FactoryBean should implement `DisposableBean` and delegate any such close call to the underlying object.

Finally, FactoryBean objects participate in the containing BeanFactory's synchronization of bean creation. Thus, there is usually no need for internal synchronization other than for purposes of lazy initialization within the FactoryBean itself (or the like).

Since:
  08.03.2003
Author:
  Rod Johnson, Juergen Hoeller
See Also:
  - `BeanFactory`
  - `org.springframework.aop.framework.ProxyFactoryBean`
  - `org.springframework.jndi.JndiObjectFactoryBean`

## Field Summary

Fields
Modifier and Type
Field
Description
`static final String`
`OBJECT_TYPE_ATTRIBUTE`
The name of an attribute that can be `set` on a `BeanDefinition` so that factory beans can signal their object type when it cannot be deduced from the factory bean class.

## Method Summary

Modifier and Type
Method
Description
`T`
`getObject()`
Return an instance (possibly shared or independent) of the object managed by this factory.
`Class<?>`
`getObjectType()`
Return the type of object that this FactoryBean creates, or `null` if not known in advance.
`default boolean`
`isSingleton()`
Is the object managed by this factory a singleton? That is, will `getObject()` always return the same object (a reference that can be cached)?

## Field Details

### OBJECT_TYPE_ATTRIBUTE

static final String OBJECT_TYPE_ATTRIBUTE
The name of an attribute that can be `set` on a `BeanDefinition` so that factory beans can signal their object type when it cannot be deduced from the factory bean class.

Since:
  5.2
See Also:
  - Constant Field Values

## Method Details

### getObject

@Nullable T getObject() throws Exception
Return an instance (possibly shared or independent) of the object managed by this factory.

As with a `BeanFactory`, this allows support for both the Singleton and Prototype design patterns.

If this FactoryBean is not fully initialized yet at the time of the call (for example because it is involved in a circular reference), throw a corresponding `FactoryBeanNotInitializedException`.

FactoryBeans are allowed to return `null` objects. The bean factory will consider this as a normal value to be used and will not throw a `FactoryBeanNotInitializedException` in this case. However, FactoryBean implementations are encouraged to throw `FactoryBeanNotInitializedException` themselves, as appropriate.

Returns:
  an instance of the bean (can be `null`)
Throws:
  `Exception` - in case of creation errors
See Also:
  - `FactoryBeanNotInitializedException`

### getObjectType

@Nullable Class<?> getObjectType()
Return the type of object that this FactoryBean creates, or `null` if not known in advance.

This allows one to check for specific types of beans without instantiating objects, for example on autowiring.

In the case of implementations that create a singleton object, this method should try to avoid singleton creation as far as possible; it should rather estimate the type in advance. For prototypes, returning a meaningful type here is advisable too.

This method can be called before this FactoryBean has been fully initialized. It must not rely on state created during initialization; of course, it can still use such state if available.

NOTE: Autowiring will simply ignore FactoryBeans that return `null` here. Therefore, it is highly recommended to implement this method properly, using the current state of the FactoryBean.

Returns:
  the type of object that this FactoryBean creates, or `null` if not known at the time of the call
See Also:
  - `ListableBeanFactory.getBeansOfType(java.lang.Class<T>)`

### isSingleton

default boolean isSingleton()
Is the object managed by this factory a singleton? That is, will `getObject()` always return the same object (a reference that can be cached)?

NOTE: If a FactoryBean indicates that it holds a singleton object, the object returned from `getObject()` might get cached by the owning BeanFactory. Hence, do not return `true` unless the FactoryBean always exposes the same reference.

The singleton status of the FactoryBean itself will generally be provided by the owning BeanFactory; usually, it has to be defined as singleton there.

NOTE: This method returning `false` does not necessarily indicate that returned objects are independent instances. An implementation of the extended `SmartFactoryBean` interface may explicitly indicate independent instances through its `SmartFactoryBean.isPrototype()` method. Plain `FactoryBean` implementations which do not implement this extended interface are simply assumed to always return independent instances if the `isSingleton()` implementation returns `false`.

The default implementation returns `true`, since a `FactoryBean` typically manages a singleton instance.

Returns:
  whether the exposed object is a singleton
See Also:
  - `getObject()`
  - `SmartFactoryBean.isPrototype()`